

// static list of named colors
NamedColor.colors = new Array();


/**
 * The color parameter should be a string of format "#rrggbb"
 */
NamedColor.getNamedColor = function(/*String*/ name, /*Color*/ color)
{
    // see if the color list already contains the specified color; if so, return it; if not, create and add
	for (var i = 0; i < NamedColor.colors.length; i++)
    {
        var namedColor = NamedColor.colors[i];
		
		// see if color matches
        if (namedColor.color.equals(color))
        {
            // if incoming name is "", it's a match whatever the name
            if ((name == "") || (name.toLowerCase() == namedColor.name.toLowerCase()))
                return namedColor;
        }
    }
    
    // don't have it; add it
    var newColor = new NamedColor(name, color);
    NamedColor.colors.push(newColor);
    return newColor;
}



NamedColor.hasNamedColor = function(/*String*/ name, /*Color*/ color)
{
    // see if the color list already contains the specified color; if so, return true; if not, false
	for (var i = 0; i < NamedColor.colors.length; i++)
    {
        var namedColor = NamedColor.colors[i];
		
		// see if color matches
        if (namedColor.color.equals(color))
        {
            // if incoming name is "", it's a match whatever the name
            if ((name == "") || (name.toLowerCase() == namedColor.name.toLowerCase()))
            {
            	return true;
            }
            else
            {
            	return false;
            }
        }
        else
    	{
    	return false;
    	}
    }
}



NamedColor.argbToColorString = function(argbString)
{
	// strip off alpha, and add leading '#'
	var colorString = "#" + argbString.substring(2);
	return colorString;
}


// prototype


function NamedColor(name, color)
{
	var self = this;
	
	self.colorChangeListeners = new Array();
	
	self.name = "";
	self.color = new Color("#000000");	// #rrggbb

	
	// initialization
	if (name != null)
		self.name = name;
	
	if (color != null)
		self.color = color;
	
	
	self.getName = function()
	{
		return self.name;
	}
	
	
	self.setName = function(/*String*/ name)
    {
        self.name = name;
        
        // broadcast change to text listeners
        
    }
	
	
	self.getARGBString = function()
	{
		// strip off "#", add alpha
		var argbString = "ff" + self.color.toHexString().substring(1);
		return argbString;
	}        
    
    
    
    self.equals = function(/*NamedColor*/ other)
    {
        if (other instanceof NamedColor)
        {
            if ( (self.name == other.name) && (self.color.equals(other.color)) )
                return true;
            else
                return false;
        }
        else
        {
            return false;
        }
    }
    
    
    self.getName = function()
    {
    	return self.name;
    }
    
    
    self.getColor = function()
    {
    	return self.color;
    }
    
    
    self.setName = function(newName)
    {
    	self.name = newName;
    	self.broadcastColorChange();
    }
    
    
    self.setColor = function(newColor)
    {
    	self.color = newColor;
    	self.broadcastColorChange();
    }
    
    
	self.addColorChangeListener = function(listener)
	{
		self.colorChangeListeners.push(listener);
	}
	
	
	self.removeColorChangeListener = function(listener)
	{
		// delete listener
		self.colorChangeListeners.splice(self.colorChangeListeners.indexOf(listener), 1);
	}
	
	
	self.broadcastColorChange = function()
	{
		for (var i = 0; i < self.colorChangeListeners.length; i++)
		{
			self.colorChangeListeners[i].onColorChange(self);
		}
	}
    

}